# AudioKit Migration Guide

This document was only begun for AudioKit 4.1, but it should be kept to date from here on.

## AudioKt 4.2 to develop

No changes yet.

## AudioKit 4.1 to 4.2

Any occurrence of AKSampler will have to be renamed AKAppleSampler if you want to continue to use this class. AKSampler is now a sampler that does not depend on Apple's AUSampler.

## AudioKit 4.0.x to AudioKit 4.1

1. Delete the AudioKit-* directories inside of Frameworks that were generated by old versions
2. Clean the build folder cmd-opt-k
3. Make sure to see the new instructions on the Frameworks/README.md concerning no longer need to run "fix-frameworks.sh" as a build phase
4. Add the standard c++ library linker flags as described on the same Frameworks README.
5. Put `AudioKit.start()` inside a do try catch block
6. Migrate to AKPlayer if you were using AKAudioPlayer if possible (its still there, but good to move away from it)


## AudioKit 3 to AudioKit 4

AudioKit 4 was more of a feature set upgrade than any major changes that would affect currently running code.
Part of the reason for this was that some major updates were postponed until Version 4.1.

## AudioKit 2.x to AudioKit 3+

AudioKit 3 was a complete rewrite from AudioKit 2, using a different audio engine internally, so 
there is no migration path between these two versions. 